import 'package:test/test.dart';
import 'package:b1simpflemobilewarehousing/b1simpflemobilewarehousing.dart';
import 'defaultconnection.dart' as conf;
void main() {
  group("B1SL_QueryTestSeries", () {
    final IItems b1s = B1ItemsServicesImpl(B1ServiceLayer(conf.connection));
    test("QueryItemsOfGroup101", () async {
      try {
        final queryResponse = await b1s.queryItemsOfGroupAsync(itemsGroupCode:101);
        expect(queryResponse,isNotNull);
        expect(queryResponse.isNotEmpty,isTrue);
        expect(queryResponse[0],isNotNull);
        print("Number of items in items group ${queryResponse.length}");
      } catch(e) {
        if(e is B1Error) {
          print("Exception is B1Error (${e.statusCode}) ${e.error.message.value} (${e.error.code}) for Query ${e.queryUrl} Payload ${e.postBody}");
        }
        expect(e,isNull);
      }
    });
  });
}
var _sampleItemJson = """
{
    "odata.metadata": "http://hana93srv:50001/b1s/v1/\$metadata#Items/@Element",
    "ItemCode": "A00001",
    "ItemName": "J.B. Officeprint 1420",
    "ForeignName": null,
    "ItemsGroupCode": 101,
    "CustomsGroupCode": -1,
    "SalesVATGroup": "",
    "BarCode": null,
    "VatLiable": "tYES",
    "PurchaseItem": "tYES",
    "SalesItem": "tYES",
    "InventoryItem": "tYES",
    "IncomeAccount": null,
    "ExemptIncomeAccount": null,
    "ExpanseAccount": null,
    "Mainsupplier": "V10000",
    "SupplierCatalogNo": null,
    "DesiredInventory": 0.0,
    "MinInventory": 0.0,
    "Picture": "A00001.jpg",
    "User_Text": "",
    "SerialNum": null,
    "CommissionPercent": 0.0,
    "CommissionSum": 0.0,
    "CommissionGroup": 0,
    "TreeType": "iNotATree",
    "AssetItem": "tNO",
    "DataExportCode": null,
    "Manufacturer": 4,
    "QuantityOnStock": 1378.0,
    "QuantityOrderedFromVendors": 93.0,
    "QuantityOrderedByCustomers": 310.0,
    "ManageSerialNumbers": "tNO",
    "ManageBatchNumbers": "tNO",
    "Valid": "tYES",
    "ValidFrom": null,
    "ValidTo": null,
    "ValidRemarks": null,
    "Frozen": "tNO",
    "FrozenFrom": null,
    "FrozenTo": null,
    "FrozenRemarks": null,
    "SalesUnit": null,
    "SalesItemsPerUnit": 1.0,
    "SalesPackagingUnit": null,
    "SalesQtyPerPackUnit": 1.0,
    "SalesUnitLength": 10.0,
    "SalesLengthUnit": 5,
    "SalesUnitWidth": 10.0,
    "SalesWidthUnit": 5,
    "SalesUnitHeight": 10.0,
    "SalesHeightUnit": 5,
    "SalesUnitVolume": 1000.0,
    "SalesVolumeUnit": 5,
    "SalesUnitWeight": 100.0,
    "SalesWeightUnit": 4,
    "PurchaseUnit": null,
    "PurchaseItemsPerUnit": 1.0,
    "PurchasePackagingUnit": null,
    "PurchaseQtyPerPackUnit": 1.0,
    "PurchaseUnitLength": 10.0,
    "PurchaseLengthUnit": 5,
    "PurchaseUnitWidth": 10.0,
    "PurchaseWidthUnit": 5,
    "PurchaseUnitHeight": 10.0,
    "PurchaseHeightUnit": 5,
    "PurchaseUnitVolume": 1000.0,
    "PurchaseVolumeUnit": 5,
    "PurchaseUnitWeight": 100.0,
    "PurchaseWeightUnit": 4,
    "PurchaseVATGroup": "",
    "SalesFactor1": 1.0,
    "SalesFactor2": 1.0,
    "SalesFactor3": 1.0,
    "SalesFactor4": 1.0,
    "PurchaseFactor1": 1.0,
    "PurchaseFactor2": 1.0,
    "PurchaseFactor3": 1.0,
    "PurchaseFactor4": 1.0,
    "MovingAveragePrice": 0.0,
    "ForeignRevenuesAccount": null,
    "ECRevenuesAccount": null,
    "ForeignExpensesAccount": null,
    "ECExpensesAccount": null,
    "AvgStdPrice": 0.0,
    "DefaultWarehouse": null,
    "ShipType": 3,
    "GLMethod": "glm_WH",
    "TaxType": "tt_Yes",
    "MaxInventory": 0.0,
    "ManageStockByWarehouse": "tYES",
    "PurchaseHeightUnit1": null,
    "PurchaseUnitHeight1": 0.0,
    "PurchaseLengthUnit1": null,
    "PurchaseUnitLength1": 0.0,
    "PurchaseWeightUnit1": null,
    "PurchaseUnitWeight1": 0.0,
    "PurchaseWidthUnit1": null,
    "PurchaseUnitWidth1": 0.0,
    "SalesHeightUnit1": null,
    "SalesUnitHeight1": 0.0,
    "SalesLengthUnit1": null,
    "SalesUnitLength1": 0.0,
    "SalesWeightUnit1": null,
    "SalesUnitWeight1": 0.0,
    "SalesWidthUnit1": null,
    "SalesUnitWidth1": 0.0,
    "ForceSelectionOfSerialNumber": "tYES",
    "ManageSerialNumbersOnReleaseOnly": "tNO",
    "WTLiable": "tYES",
    "CostAccountingMethod": "bis_MovingAverage",
    "SWW": null,
    "WarrantyTemplate": null,
    "IndirectTax": "tNO",
    "ArTaxCode": null,
    "ApTaxCode": null,
    "BaseUnitName": null,
    "ItemCountryOrg": null,
    "IssueMethod": "im_Backflush",
    "SRIAndBatchManageMethod": "bomm_OnEveryTransaction",
    "IsPhantom": "tNO",
    "InventoryUOM": null,
    "PlanningSystem": "bop_MRP",
    "ProcurementMethod": "bom_Buy",
    "ComponentWarehouse": "bomcw_BOM",
    "OrderIntervals": null,
    "OrderMultiple": 0.0,
    "LeadTime": null,
    "MinOrderQuantity": 0.0,
    "ItemType": "itItems",
    "ItemClass": "itcMaterial",
    "OutgoingServiceCode": null,
    "IncomingServiceCode": null,
    "ServiceGroup": null,
    "NCMCode": null,
    "MaterialType": "mt_FinishedGoods",
    "MaterialGroup": -1,
    "ProductSource": "1",
    "Properties1": "tNO",
    "Properties2": "tNO",
    "Properties3": "tNO",
    "Properties4": "tNO",
    "Properties5": "tNO",
    "Properties6": "tNO",
    "Properties7": "tNO",
    "Properties8": "tNO",
    "Properties9": "tNO",
    "Properties10": "tNO",
    "Properties11": "tNO",
    "Properties12": "tNO",
    "Properties13": "tNO",
    "Properties14": "tNO",
    "Properties15": "tNO",
    "Properties16": "tNO",
    "Properties17": "tNO",
    "Properties18": "tNO",
    "Properties19": "tNO",
    "Properties20": "tNO",
    "Properties21": "tNO",
    "Properties22": "tNO",
    "Properties23": "tNO",
    "Properties24": "tNO",
    "Properties25": "tNO",
    "Properties26": "tNO",
    "Properties27": "tNO",
    "Properties28": "tNO",
    "Properties29": "tNO",
    "Properties30": "tNO",
    "Properties31": "tNO",
    "Properties32": "tNO",
    "Properties33": "tNO",
    "Properties34": "tNO",
    "Properties35": "tNO",
    "Properties36": "tNO",
    "Properties37": "tNO",
    "Properties38": "tNO",
    "Properties39": "tNO",
    "Properties40": "tNO",
    "Properties41": "tNO",
    "Properties42": "tNO",
    "Properties43": "tNO",
    "Properties44": "tNO",
    "Properties45": "tNO",
    "Properties46": "tNO",
    "Properties47": "tNO",
    "Properties48": "tNO",
    "Properties49": "tNO",
    "Properties50": "tNO",
    "Properties51": "tNO",
    "Properties52": "tNO",
    "Properties53": "tNO",
    "Properties54": "tNO",
    "Properties55": "tNO",
    "Properties56": "tNO",
    "Properties57": "tNO",
    "Properties58": "tNO",
    "Properties59": "tNO",
    "Properties60": "tNO",
    "Properties61": "tNO",
    "Properties62": "tNO",
    "Properties63": "tNO",
    "Properties64": "tNO",
    "AutoCreateSerialNumbersOnRelease": "tNO",
    "DNFEntry": -1,
    "GTSItemSpec": null,
    "GTSItemTaxCategory": null,
    "FuelID": -1,
    "BeverageTableCode": null,
    "BeverageGroupCode": null,
    "BeverageCommercialBrandCode": -1,
    "Series": 37,
    "ToleranceDays": null,
    "TypeOfAdvancedRules": "toarGeneral",
    "IssuePrimarilyBy": "ipbSerialAndBatchNumbers",
    "NoDiscounts": "tNO",
    "AssetClass": null,
    "AssetGroup": null,
    "InventoryNumber": null,
    "Technician": null,
    "Employee": null,
    "Location": null,
    "AssetStatus": "New",
    "CapitalizationDate": null,
    "StatisticalAsset": "tNO",
    "Cession": "tNO",
    "DeactivateAfterUsefulLife": "tNO",
    "ManageByQuantity": "tNO",
    "UoMGroupEntry": -1,
    "InventoryUoMEntry": -1,
    "DefaultSalesUoMEntry": null,
    "DefaultPurchasingUoMEntry": null,
    "DepreciationGroup": null,
    "AssetSerialNumber": null,
    "InventoryWeight": null,
    "InventoryWeightUnit": null,
    "InventoryWeight1": null,
    "InventoryWeightUnit1": null,
    "DefaultCountingUnit": null,
    "CountingItemsPerUnit": 1.0,
    "DefaultCountingUoMEntry": null,
    "Excisable": "tNO",
    "ChapterID": -1,
    "ScsCode": null,
    "SpProdType": null,
    "ProdStdCost": null,
    "InCostRollup": "tYES",
    "VirtualAssetItem": "tNO",
    "EnforceAssetSerialNumbers": "tNO",
    "AttachmentEntry": null,
    "LinkedResource": null,
    "UpdateDate": "2016-08-05",
    "UpdateTime": "23:18:39",
    "GSTRelevnt": "tNO",
    "SACEntry": -1,
    "GSTTaxCategory": "gtc_Regular",
    "ServiceCategoryEntry": -1,
    "CapitalGoodsOnHoldPercent": null,
    "CapitalGoodsOnHoldLimit": null,
    "AssessableValue": null,
    "AssVal4WTR": null,
    "SOIExcisable": "se_NotExcisable",
    "TNVED": null,
    "ImportedItem": "tNO",
    "PricingUnit": -1,
    "CreateDate": "2007-04-09",
    "CreateTime": "00:00:00",
    "ItemPrices": [
       {
          "PriceList": 1,
          "Price": 400.0,
          "Currency": "\$",
          "AdditionalPrice1": null,
          "AdditionalCurrency1": null,
          "AdditionalPrice2": null,
          "AdditionalCurrency2": null,
          "BasePriceList": 1,
          "Factor": 1.0,
          "UoMPrices": []
       },
       {
          "PriceList": 2,
          "Price": 200.0,
          "Currency": "\$",
          "AdditionalPrice1": null,
          "AdditionalCurrency1": null,
          "AdditionalPrice2": null,
          "AdditionalCurrency2": null,
          "BasePriceList": 1,
          "Factor": 0.50,
          "UoMPrices": []
       },
       {
          "PriceList": 3,
          "Price": 300.0,
          "Currency": "\$",
          "AdditionalPrice1": null,
          "AdditionalCurrency1": null,
          "AdditionalPrice2": null,
          "AdditionalCurrency2": null,
          "BasePriceList": 1,
          "Factor": 0.750,
          "UoMPrices": []
       },
       {
          "PriceList": 4,
          "Price": 500.0,
          "Currency": "\$",
          "AdditionalPrice1": null,
          "AdditionalCurrency1": null,
          "AdditionalPrice2": null,
          "AdditionalCurrency2": null,
          "BasePriceList": 1,
          "Factor": 1.250,
          "UoMPrices": []
       },
       {
          "PriceList": 5,
          "Price": 600.0,
          "Currency": "\$",
          "AdditionalPrice1": null,
          "AdditionalCurrency1": null,
          "AdditionalPrice2": null,
          "AdditionalCurrency2": null,
          "BasePriceList": 1,
          "Factor": 1.50,
          "UoMPrices": []
       },
       {
          "PriceList": 6,
          "Price": 700.0,
          "Currency": "\$",
          "AdditionalPrice1": null,
          "AdditionalCurrency1": null,
          "AdditionalPrice2": null,
          "AdditionalCurrency2": null,
          "BasePriceList": 1,
          "Factor": 1.750,
          "UoMPrices": []
       }
    ],
    "ItemWarehouseInfoCollection": [
       {
          "MinimalStock": 0.0,
          "MaximalStock": 0.0,
          "MinimalOrder": 0.0,
          "StandardAveragePrice": 302.370,
          "Locked": "tNO",
          "InventoryAccount": null,
          "CostAccount": null,
          "TransferAccount": null,
          "RevenuesAccount": null,
          "VarienceAccount": null,
          "DecreasingAccount": null,
          "IncreasingAccount": null,
          "ReturningAccount": null,
          "ExpensesAccount": null,
          "EURevenuesAccount": null,
          "EUExpensesAccount": null,
          "ForeignRevenueAcc": null,
          "ForeignExpensAcc": null,
          "ExemptIncomeAcc": null,
          "PriceDifferenceAcc": null,
          "WarehouseCode": "01",
          "InStock": 1328.0,
          "Committed": 310.0,
          "Ordered": 93.0,
          "CountedQuantity": 0.0,
          "WasCounted": "tNO",
          "UserSignature": 1,
          "Counted": 0.0,
          "ExpenseClearingAct": null,
          "PurchaseCreditAcc": null,
          "EUPurchaseCreditAcc": null,
          "ForeignPurchaseCreditAcc": null,
          "SalesCreditAcc": null,
          "SalesCreditEUAcc": null,
          "ExemptedCredits": null,
          "SalesCreditForeignAcc": null,
          "ExpenseOffsettingAccount": null,
          "WipAccount": null,
          "ExchangeRateDifferencesAcct": null,
          "GoodsClearingAcct": null,
          "NegativeInventoryAdjustmentAccount": null,
          "CostInflationOffsetAccount": null,
          "GLDecreaseAcct": null,
          "GLIncreaseAcct": null,
          "PAReturnAcct": null,
          "PurchaseAcct": null,
          "PurchaseOffsetAcct": null,
          "ShippedGoodsAccount": null,
          "StockInflationOffsetAccount": null,
          "StockInflationAdjustAccount": null,
          "VATInRevenueAccount": null,
          "WipVarianceAccount": null,
          "CostInflationAccount": null,
          "WHIncomingCenvatAccount": null,
          "WHOutgoingCenvatAccount": null,
          "StockInTransitAccount": null,
          "WipOffsetProfitAndLossAccount": null,
          "InventoryOffsetProfitAndLossAccount": null,
          "DefaultBin": null,
          "DefaultBinEnforced": "tNO",
          "PurchaseBalanceAccount": null,
          "ItemCode": "A00001",
          "ItemCycleCounts": [
             {
                "CycleCode": 1,
                "Alert": "tYES",
                "NextCountingDate": "2016-08-05",
                "AlertTime": null,
                "DestinationUser": 1,
                "WarehouseCode": "01"
             }
          ]
       },
       {
          "MinimalStock": 0.0,
          "MaximalStock": 0.0,
          "MinimalOrder": 0.0,
          "StandardAveragePrice": 400.0,
          "Locked": "tNO",
          "InventoryAccount": null,
          "CostAccount": null,
          "TransferAccount": null,
          "RevenuesAccount": null,
          "VarienceAccount": null,
          "DecreasingAccount": null,
          "IncreasingAccount": null,
          "ReturningAccount": null,
          "ExpensesAccount": null,
          "EURevenuesAccount": null,
          "EUExpensesAccount": null,
          "ForeignRevenueAcc": null,
          "ForeignExpensAcc": null,
          "ExemptIncomeAcc": null,
          "PriceDifferenceAcc": null,
          "WarehouseCode": "02",
          "InStock": 50.0,
          "Committed": 0.0,
          "Ordered": 0.0,
          "CountedQuantity": 0.0,
          "WasCounted": "tNO",
          "UserSignature": 1,
          "Counted": 0.0,
          "ExpenseClearingAct": null,
          "PurchaseCreditAcc": null,
          "EUPurchaseCreditAcc": null,
          "ForeignPurchaseCreditAcc": null,
          "SalesCreditAcc": null,
          "SalesCreditEUAcc": null,
          "ExemptedCredits": null,
          "SalesCreditForeignAcc": null,
          "ExpenseOffsettingAccount": null,
          "WipAccount": null,
          "ExchangeRateDifferencesAcct": null,
          "GoodsClearingAcct": null,
          "NegativeInventoryAdjustmentAccount": null,
          "CostInflationOffsetAccount": null,
          "GLDecreaseAcct": null,
          "GLIncreaseAcct": null,
          "PAReturnAcct": null,
          "PurchaseAcct": null,
          "PurchaseOffsetAcct": null,
          "ShippedGoodsAccount": null,
          "StockInflationOffsetAccount": null,
          "StockInflationAdjustAccount": null,
          "VATInRevenueAccount": null,
          "WipVarianceAccount": null,
          "CostInflationAccount": null,
          "WHIncomingCenvatAccount": null,
          "WHOutgoingCenvatAccount": null,
          "StockInTransitAccount": null,
          "WipOffsetProfitAndLossAccount": null,
          "InventoryOffsetProfitAndLossAccount": null,
          "DefaultBin": null,
          "DefaultBinEnforced": "tNO",
          "PurchaseBalanceAccount": null,
          "ItemCode": "A00001",
          "ItemCycleCounts": []
       },
       {
          "MinimalStock": 0.0,
          "MaximalStock": 0.0,
          "MinimalOrder": 0.0,
          "StandardAveragePrice": 0.0,
          "Locked": "tNO",
          "InventoryAccount": null,
          "CostAccount": null,
          "TransferAccount": null,
          "RevenuesAccount": null,
          "VarienceAccount": null,
          "DecreasingAccount": null,
          "IncreasingAccount": null,
          "ReturningAccount": null,
          "ExpensesAccount": null,
          "EURevenuesAccount": null,
          "EUExpensesAccount": null,
          "ForeignRevenueAcc": null,
          "ForeignExpensAcc": null,
          "ExemptIncomeAcc": null,
          "PriceDifferenceAcc": null,
          "WarehouseCode": "03",
          "InStock": 0.0,
          "Committed": 0.0,
          "Ordered": 0.0,
          "CountedQuantity": 0.0,
          "WasCounted": "tNO",
          "UserSignature": 1,
          "Counted": 0.0,
          "ExpenseClearingAct": null,
          "PurchaseCreditAcc": null,
          "EUPurchaseCreditAcc": null,
          "ForeignPurchaseCreditAcc": null,
          "SalesCreditAcc": null,
          "SalesCreditEUAcc": null,
          "ExemptedCredits": null,
          "SalesCreditForeignAcc": null,
          "ExpenseOffsettingAccount": null,
          "WipAccount": null,
          "ExchangeRateDifferencesAcct": null,
          "GoodsClearingAcct": null,
          "NegativeInventoryAdjustmentAccount": null,
          "CostInflationOffsetAccount": null,
          "GLDecreaseAcct": null,
          "GLIncreaseAcct": null,
          "PAReturnAcct": null,
          "PurchaseAcct": null,
          "PurchaseOffsetAcct": null,
          "ShippedGoodsAccount": null,
          "StockInflationOffsetAccount": null,
          "StockInflationAdjustAccount": null,
          "VATInRevenueAccount": null,
          "WipVarianceAccount": null,
          "CostInflationAccount": null,
          "WHIncomingCenvatAccount": null,
          "WHOutgoingCenvatAccount": null,
          "StockInTransitAccount": null,
          "WipOffsetProfitAndLossAccount": null,
          "InventoryOffsetProfitAndLossAccount": null,
          "DefaultBin": null,
          "DefaultBinEnforced": "tNO",
          "PurchaseBalanceAccount": null,
          "ItemCode": "A00001",
          "ItemCycleCounts": []
       },
       {
          "MinimalStock": 0.0,
          "MaximalStock": 0.0,
          "MinimalOrder": 0.0,
          "StandardAveragePrice": 0.0,
          "Locked": "tNO",
          "InventoryAccount": null,
          "CostAccount": null,
          "TransferAccount": null,
          "RevenuesAccount": null,
          "VarienceAccount": null,
          "DecreasingAccount": null,
          "IncreasingAccount": null,
          "ReturningAccount": null,
          "ExpensesAccount": null,
          "EURevenuesAccount": null,
          "EUExpensesAccount": null,
          "ForeignRevenueAcc": null,
          "ForeignExpensAcc": null,
          "ExemptIncomeAcc": null,
          "PriceDifferenceAcc": null,
          "WarehouseCode": "04",
          "InStock": 0.0,
          "Committed": 0.0,
          "Ordered": 0.0,
          "CountedQuantity": 0.0,
          "WasCounted": "tNO",
          "UserSignature": 1,
          "Counted": 0.0,
          "ExpenseClearingAct": null,
          "PurchaseCreditAcc": null,
          "EUPurchaseCreditAcc": null,
          "ForeignPurchaseCreditAcc": null,
          "SalesCreditAcc": null,
          "SalesCreditEUAcc": null,
          "ExemptedCredits": null,
          "SalesCreditForeignAcc": null,
          "ExpenseOffsettingAccount": null,
          "WipAccount": null,
          "ExchangeRateDifferencesAcct": null,
          "GoodsClearingAcct": null,
          "NegativeInventoryAdjustmentAccount": null,
          "CostInflationOffsetAccount": null,
          "GLDecreaseAcct": null,
          "GLIncreaseAcct": null,
          "PAReturnAcct": null,
          "PurchaseAcct": null,
          "PurchaseOffsetAcct": null,
          "ShippedGoodsAccount": null,
          "StockInflationOffsetAccount": null,
          "StockInflationAdjustAccount": null,
          "VATInRevenueAccount": null,
          "WipVarianceAccount": null,
          "CostInflationAccount": null,
          "WHIncomingCenvatAccount": null,
          "WHOutgoingCenvatAccount": null,
          "StockInTransitAccount": null,
          "WipOffsetProfitAndLossAccount": null,
          "InventoryOffsetProfitAndLossAccount": null,
          "DefaultBin": null,
          "DefaultBinEnforced": "tNO",
          "PurchaseBalanceAccount": null,
          "ItemCode": "A00001",
          "ItemCycleCounts": []
       },
       {
          "MinimalStock": 0.0,
          "MaximalStock": 0.0,
          "MinimalOrder": 0.0,
          "StandardAveragePrice": 0.0,
          "Locked": "tNO",
          "InventoryAccount": null,
          "CostAccount": null,
          "TransferAccount": null,
          "RevenuesAccount": null,
          "VarienceAccount": null,
          "DecreasingAccount": null,
          "IncreasingAccount": null,
          "ReturningAccount": null,
          "ExpensesAccount": null,
          "EURevenuesAccount": null,
          "EUExpensesAccount": null,
          "ForeignRevenueAcc": null,
          "ForeignExpensAcc": null,
          "ExemptIncomeAcc": null,
          "PriceDifferenceAcc": null,
          "WarehouseCode": "05",
          "InStock": 0.0,
          "Committed": 0.0,
          "Ordered": 0.0,
          "CountedQuantity": 0.0,
          "WasCounted": "tNO",
          "UserSignature": 1,
          "Counted": 0.0,
          "ExpenseClearingAct": null,
          "PurchaseCreditAcc": null,
          "EUPurchaseCreditAcc": null,
          "ForeignPurchaseCreditAcc": null,
          "SalesCreditAcc": null,
          "SalesCreditEUAcc": null,
          "ExemptedCredits": null,
          "SalesCreditForeignAcc": null,
          "ExpenseOffsettingAccount": null,
          "WipAccount": null,
          "ExchangeRateDifferencesAcct": null,
          "GoodsClearingAcct": null,
          "NegativeInventoryAdjustmentAccount": null,
          "CostInflationOffsetAccount": null,
          "GLDecreaseAcct": null,
          "GLIncreaseAcct": null,
          "PAReturnAcct": null,
          "PurchaseAcct": null,
          "PurchaseOffsetAcct": null,
          "ShippedGoodsAccount": null,
          "StockInflationOffsetAccount": null,
          "StockInflationAdjustAccount": null,
          "VATInRevenueAccount": null,
          "WipVarianceAccount": null,
          "CostInflationAccount": null,
          "WHIncomingCenvatAccount": null,
          "WHOutgoingCenvatAccount": null,
          "StockInTransitAccount": null,
          "WipOffsetProfitAndLossAccount": null,
          "InventoryOffsetProfitAndLossAccount": null,
          "DefaultBin": null,
          "DefaultBinEnforced": "tNO",
          "PurchaseBalanceAccount": null,
          "ItemCode": "A00001",
          "ItemCycleCounts": []
       }
    ],
    "ItemPreferredVendors": [
       {
          "BPCode": "V10000"
       }
    ],
    "ItemLocalizationInfos": [],
    "ItemProjects": [],
    "ItemDistributionRules": [],
    "ItemAttributeGroups": [],
    "ItemDepreciationParameters": [],
    "ItemPeriodControls": [],
    "ItemUnitOfMeasurementCollection": [],
    "ItemBarCodeCollection": [],
    "ItemIntrastatExtension": {
       "ItemCode": "A00001",
       "CommodityCode": null,
       "SupplementaryUnit": null,
       "FactorOfSupplementaryUnit": 0.0,
       "ImportRegionState": null,
       "ExportRegionState": null,
       "ImportNatureOfTransaction": null,
       "ExportNatureOfTransaction": null,
       "ImportStatisticalProcedure": null,
       "ExportStatisticalProcedure": null,
       "CountryOfOrigin": null,
       "ServiceCode": null,
       "Type": "dDocument_Items",
       "ServiceSupplyMethod": "ssmImmediate",
       "ServicePaymentMethod": "spmOther",
       "ImportRegionCountry": "US",
       "ExportRegionCountry": "US",
       "UseWeightInCalculation": "tYES",
       "IntrastatRelevant": "tNO",
       "StatisticalCode": null
    }
 }
 """;
